
#ifndef CORA_H
#define CORA_H

#include <gtk/gtk.h>

#define C_LIGHT 299792.458

#define MAXPATH 512
#define MAXTEXTL 128
#define NENTRY   25
#define MAXLINES 128
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#include "config.h"

/*      program flags    */
extern int ireplot;
extern int    verbose;
extern int    quiet;

extern gchar fittitle[MAXTEXTL];
extern char version[5];
extern int nlines, sigunit, ikev, sbgit, bgsmooth, sbgchi, ilamit, isigit, iformat, iportrait;
extern int ires, iplot, ierrplot, ilab, ilog, nbin, spec_only, fit_only, nlik, ispline, idlam, idsig;

extern double lambda[MAXLINES],sigma[MAXLINES],f[MAXLINES],app_s,app_b,sbg,v;
extern double dsig,dlam, iord,medsig;
extern int fixflag;
extern   float * wave, * flux, * bb, * err;
extern   int   count;
extern double dt;

#define P_MIN    0
#define P_GAUSS  0
#define P_LORENZ 1
#define P_MAX    1
extern int    pro_type[MAXLINES];     /* the profile type          */
extern int    fit_wave[MAXLINES];     /* whether to fit wavelength */
extern int    fit_sigm[MAXLINES];     /* whether to fit sigme      */
extern int    fit_lock[MAXLINES];     /* lock lambda to previous   */
extern float  beta[MAXLINES];         /* exponent in Beta model    */

float float_min (float * inArr, int size, int * index);
float float_max (float * inArr, int size, int * index);
double double_max (double * inArr, int size);
double double_min (double * inArr, int size);

int getlambda(float * xposition, float * yposition, 
	      int * numlines);
int read_input (char *path, int s_flag);
int read_spec (char *path, int s_flag);

void
create_frame (GtkWidget * vbox, GtkWidget * box_loop, char *title);
GtkWidget *
create_entry (GtkWidget * box_loop, void *enter_callback, char *callarg,
              char *deftext, char *labtext);
GtkWidget *
create_toggle (GtkWidget * box_loop, void *enter_switch, char *callarg,
               char *deftext, char *labtext);
GtkWidget *
create_spin (GtkWidget * box_loop, GtkAdjustment * adj,
             void *enter_spin, char *callarg, char *labtext);
GtkWidget *
create_spin_float (GtkWidget * box_loop, GtkAdjustment * adj,
             void *enter_spin, char *callarg, char *labtext);


#endif
