/* praxis1.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lm   (in that order)
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <assert.h>
#include "cora_fit.h"

/* double ftest_(x, n) 
   double *x;
   int *n;
*/

#define NDEBUG /*  remove this line to get Bug reports  */

/* #ifndef NDEBUG */
#define myassert(expr) \
  do { if (!(expr)) {                                                         \
           fprintf(stderr,                                                    \
		   "** ERROR ** failed assertion in file %s, line %d\n",      \
                           __FILE__, __LINE__);                               \
           abort(); }                                                         \
     } while (1 == 0)
/* #else
#define myassert(expr)
#endif */

/* Common Block Declarations */

typedef struct {
  double v[( 2 * MAXLINES) * (2 * MAXLINES)]; 
  double x[2 * MAXLINES];
  double d[2 * MAXLINES]; 
  double q0[2 * MAXLINES]; 
  double q1[2 * MAXLINES]; 
  double dmin__;
  double epsmch; 
  double fx;
  double h;
  double qd0; 
  double qd1; 
  double qf1; 
  double small; 
  double t;
  double xldt; 
  double xm2;
  double xm4; 
  double dseed; 
  double scbd;
  int    n;       /* dimension         */
  int    nl; 
  int    nf;
  int    lp; 
  int    jprint; 
  int    nmax;
  int    illcin; 
  int    ktm;
  int    nfmax;   /* maximum dimension */ 
  int    jranch;
} cprax_;

/* #define cprax_1 cprax_ */


/* random number generator
 */
struct {
    double ran3[127], ran1;
    int jran2;
} comran_;

#define comran_1 comran_

/* Table of constant values */

static int c__0     = 0;
static int c__1     = 1;
static int c__2     = 2;
static int c__4     = 4;

#ifndef NDEBUG
static int gi;
#endif

static double c_b83 = 4.;

static double c_b310 = 8190.;
static double c_b313 = 8191.;

static double c_b314 = 32.;
static double c_b318 = 2147483647.;

/* Internal subroutines
 */
static int    praset_(cprax_ * cprax1, double ftol);
static int    praxis_(cprax_ * cprax1, double (*f)());
static int    ranini_( );
static int    random_( );
static int    quad_(cprax_ * cprax1, double (*f) ());
static int    sort_(cprax_ * cprax1 );
static int    mymin_(cprax_ * cprax1, int *j, int *nits, double *d2, 
		     double *x1, double *f1, int *ifk, double (*f) ());
static int    minfit_(cprax_ * cprax1, int *n, double *eps, double *tol, 
		      double *ab, double *q, double *e, int *nmax, int *lp);
static double drandm_( );
static int    flin_(cprax_ * cprax1, double *xl, int *j, double (*f) (), 
		    double *fln);

int MinFinder (double * t2, double low, double up, 
	       double ftol, double * fmin, double (*func)())
{

  /****
   * Uses Brents algorithm, which is a combination of golden section 
   * search and parabolic interpolation.
   * Adopted from procedure 'localmin' in: Richard Brent, Algorithms for
   * minimization without derivatives, Prentice-Hall, Inc. (1973)
   ****/

  register      int i;                 /* loop variable                     */
  double        step, stepstore;       /* stepsizes                         */
  double        Fe = 0.0, Ff = 0.0;    /* function values                   */
  double        Fg = 0.0, Fh = 0.0;    /* function values                   */
  double        e = 0.0, f, g, h;      /* positions (parametric)            */
  double        delta1, delta2;        /* test convergence                  */
  double        Start, End, Middle;    /* brackets                          */
  double        nextstep = 0.0;        /* stepsize                          */
  double        P1 = 0.0, P2, P3;      /* fit parabola                      */
  int           NN = 1;
  double        first, ffirst;

#define GRID_NUM 11

  double        grid_f[GRID_NUM];
  double        grid_x[GRID_NUM];
  double        grid_min;
  int           grid_ind;

  Start = low;
  End   = up;

  first  = (*t2);
  ffirst = func (&first, &NN);


  /* do an initial grid search
   */
  h = (End - Start) / (GRID_NUM - 1);

  grid_x[0] = Start;
  grid_f[0] = func (&grid_x[0], &NN);
  grid_min  = grid_f[0];
  grid_ind  = 0;

  if (verbose > 2)
    fprintf(stdout, 
	    "Message      : MinFinder: X: %12.6f   "\
	    "F(X): %15.6f  (grid - 00)\n", 
	    grid_x[0],  grid_f[0]);

  for (i = 1; i < GRID_NUM; ++i)
    {
      grid_x[i] = Start + (i * h); 
      grid_f[i] = func (&grid_x[i], &NN);
      if (verbose > 2)
	fprintf(stdout, 
		"Message      : MinFinder: X: %12.6f   "\
		"F(X): %15.6f  (grid - %02d)\n", 
		grid_x[i],  grid_f[i], i);
      if (grid_f[i] < grid_min)
	{
	  grid_min  = grid_f[i];
	  grid_ind  = i;
	}
    }

  if (grid_min < ffirst)
    {
      if (grid_ind < 1)
	{
	  Start = grid_x[0];
	  End   = grid_x[3];
	}
      else if (grid_ind > GRID_NUM - 2)
	{
	  Start = grid_x[7];
	  End   = grid_x[10];
	}
      else
	{
	  Start = grid_x[grid_ind - 1];
	  End   = grid_x[grid_ind + 1];
	}
    }

  step = 0.0;

  (*t2) = 0.62 * (Start) + 0.38 * (End);

  /* t2 is the initial guess for the minimum between t1 and t3              */
  h = g = f = (*t2);


  /* initial value of F                                                     */
  Ff = Fg = Fh = func (t2, &NN);

  if (verbose > 0)
    fprintf(stdout, "Message      : MinFinder: X: %12.6f   "\
	    "F(X): %15.6f  (start)\n", 
            h, Fh);

#define MAXITER 1000

  for (i = MAXITER; i; --i) {

    Middle = 0.5 * (Start + End);

    delta1 = ftol * fabs(h) + DBL_EPSILON;
    delta2 = 2.0 * delta1;

    /* test for convergence                                                 */
    /* RETURN if converged                                                  */

    if (fabs(h-Middle) <= (delta2 - 0.5 * (End-Start) ) ) {
      *t2   = h;
      *fmin = Fh;
      if (verbose > 2)
	fprintf(stdout, 
                "Message      : MinFinder: X: %12.6f   "\
		"F(X): %15.6f  (converged)\n", 
                h, Fh);
      return (MAXITER - i);
    }

    if (fabs(step) >= delta1) {

      /* fit parabola                                                       */
      P3 = (h-g)*(Fh-Ff);
      P2 = (h-f)*(Fh-Fg);
      P1 = (h-f)*P2 - (h-g)*P3;
      P2 = 2.0 * (P2 - P3);

      if (P2 >= DBL_EPSILON) { 
        P1 = -P1; 
      } else {
        P2 = -P2;
      }

      stepstore = step;
      step = nextstep;

      if ( (fabs(P1) >= fabs(0.5 * P2 * stepstore)) 
           || (P1 <= P2*(Start-h)) 
           || (P1 >= P2*(End-h))) {

        /* a golden-section step                                            */
        if (h >= Middle) { 
          step = (Start-h); 
        } else {  
          step = (End-h);
        }
        nextstep = 0.381966 * step;

      } else {

        /* do a parabolic interpolation step                                */
        nextstep = P1/P2;
        e        = h + nextstep;

        /* f must not be evaluated too close to Start or End                */
        if ((e-Start) <= delta2 || (End-e) <= delta2) {
          if ((Middle-h) <= (-DBL_EPSILON)) { 
            nextstep = nextstep-delta1; 
          } else { 
            nextstep = nextstep+delta1;
          }
        }

      }

    } else {

      /* a golden-section step                                              */
      if (h >= Middle) { 
        step = (Start-h); 
      } else {  
        step = (End-h);
      }
      nextstep =  0.381966 * step;
      
    }

    if (fabs(nextstep) >= delta1) { 
      e = h + nextstep; 
    } else {
      /* f must not be evaluated too close                                  */
      if ( nextstep <= (-DBL_EPSILON) ) { 
        e = h - delta1; 
      } else { 
        e = h + delta1; 
      }
    }

    /* e ist the current best guess for the minimum                         */
    Fe         = func (&e, &NN);
    if (verbose > 2)
      fprintf(stdout, 
              "Message      : MinFinder: X: %12.6f   "\
	      "F(X): %15.6f  (running)\n", 
               e, Fe);

    /* update                                                               */
    if (Fe <= Fh) {
      if ( e >= h ) Start = h; 
      else End = h;
      f  =  g;  g =  h;  h = e;
      Ff = Fg; Fg = Fh; Fh = Fe;
    } else {
      if ( e <= (h-DBL_EPSILON) ) Start = e; 
      else End = e;
      if ( (Fe <= Fg) || (fabs (g - e)  <= FLT_EPSILON) ) {
        f = g; g = e; 
        Ff = Fg; Fg = Fe;
      } 
      else if ( (Fe <= Ff) || (fabs (f- g) <= FLT_EPSILON) 
                || (fabs (f - h) <= FLT_EPSILON) ) { 
          f = e; Ff = Fe;
      }
    }

  /* end of main loop                                                       */
  }

  /* only reach here if no convergence                                      */
  *t2   = h;     
  *fmin = Fh;

  if (verbose > 2)
    fprintf(stdout, 
            "Message      : MinFinder: X: %12.6f   "\
	    "F(X): %15.6f  (not converged)\n", 
             h, Fh);

  return (-1);
}
    


/* This is the main driver function for the Powell minimization 
 * routine.
 *
 * startvec: starting point (n-dimensional),
 *           on output replaced with the location of the minimum.
 * n       : dimension of startvec
 * ftol    : tolerance (convergence criterium)
 * fmin    : contains function value on output
 * f       : a function defined as:   double function_name(double * x, int * n)
 */
int powell (double * startvec, int n, double ftol, double * fmin, 
	    double (*f)(), double dstep)
{
  register int i;
  cprax_ * cprax1;
  int      nf;

  cprax1 = (cprax_ *) malloc (sizeof(cprax_));

  if (n < 1)
    {
      fprintf (stderr, "* Warning *: powell(): dimension n < 1\n");
      return (-1);
    }

  if (startvec == NULL)
    {
      fprintf (stderr, "* Warning *: powell(): starting vector is NULL\n");
      return (-1);
    }
      
  if (startvec == NULL)
    {
      fprintf (stderr, "* Warning *: powell(): pointer to fmin is NULL\n");
      return (-1);
    }

  if (f == NULL)
    {
      fprintf (stderr, 
	       "* Warning *: powell(): minimization function f is NULL\n");
      return (-1);
    }

  if (n == 1)
    {
      if (ilamit == 1)
         return MinFinder (startvec, lP.vec[0],uP.vec[0],ftol, fmin, f);
      else if(isigit == 1)
	 return MinFinder (startvec, lP.vec[nlines], 
			   uP.vec[nlines], ftol, fmin, f);
    }

  /* Initialize.
   */
  praset_(cprax1,ftol);
  cprax1->h=dstep;

  for (i = 0; i < n; ++i)
    cprax1->x[i] = startvec[i];

  cprax1->nfmax = 16 * 200 + n * 200;
  cprax1->n     = n;  
 
  /* Minimize.
   */
  praxis_ (cprax1,f);

  /* Set output values.
   */
  for (i = 0; i < n; ++i)
    {
	if (finite(startvec[i]) != 0)
           startvec[i] = cprax1->x[i];
        else
           {
              fprintf (stderr, "* Warning *: powell(): NaN in result\n");
              return (-1);
           }
    }
	
  *fmin = cprax1->fx;

  nf = cprax1->nf;
  free(cprax1);

  return (nf);
}



/*  PRAXIS.CNTL          PRAXIS 1.2     SEPTEMBER 1995             */
/*                                                                 */
/*  RECENT CHANGES...                                              */
/*     ERROR CORRECTED IN FUNCTION FTEST (SEE BELOW) 25 SEPT. 1995 */
/*     IMPLICIT STATEMENTS REMOVED AND                             */
/*        DOCUMENTATION ADDED TO SUBROUTINE TESTIN 26 SEPT. 1995   */
/*                                                                 */
/*  MAIN PROGRAM TO TEST SUBROUTINE PRAXIS BY BRENT                */
/*                                                                 */
/*  J. P. CHANDLER, COMPUTER SCIENCE DEPARTMENT,                   */
/*     OKLAHOMA STATE UNIVERSITY, STILLWATER, OK 74078             */
/*                                                                 */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",             */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGE 138                 */


/*  PRASET 1.0           JUNE 1995 */

/*  SET INITIAL VALUES FOR SOME QUANTITIES USED IN SUBROUTINE PRAXIS. */
/*  THE USER CAN RESET THESE, IF DESIRED,                             */
/*  AFTER CALLING PRASET AND BEFORE CALLING PRAXIS.                   */
/*                                                                    */
/*  J. P. CHANDLER, COMPUTER SCIENCE DEPARTMENT,                      */
/*     OKLAHOMA STATE UNIVERSITY                                      */
/*                                                                    */
/*  ON MANY MACHINES, SUBROUTINE PRAXIS WILL CAUSE UNDERFLOW AND/OR   */
/*  DIVIDE CHECK WHEN COMPUTING EPSMCH**4 AND EPSMCH**(-4).           */
/*  IN THAT CASE, SET EPSMCH=1.0D-9 (OR POSSIBLY EPSMCH=1.0D-8)       */
/*  AFTER CALLING SUBROUTINE PRASET.                                  */

int praset_(cprax_ * cprax1, double ftol)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static double xmid, rtwo, a, b;
    int j;
    static double rzero, unitr, xplus;

    rzero = 0.;
    unitr = 1.;
    rtwo = 2.;

/*  NMAX IS THE DIMENSION OF THE ARRAYS V(*,*), X(*), D(*), */
/*  Q0(*), AND Q1(*). */

    cprax1->nmax = (MAXLINES * 2);

/*  NFMAX IS THE MAXIMUM NUMBER OF FUNCTION EVALUATIONS PERMITTED. */

    cprax1->nfmax = 100000;

/*  LP IS THE LOGICAL UNIT NUMBER FOR PRINTED OUTPUT. */

    cprax1->lp = 6;

/*  T IS A CONVERGENCE TOLERANCE USED IN SUBROUTINE PRAXIS. */

    cprax1->t = ftol;

/*  JPRINT CONTROLS PRINTED OUTPUT IN PRAXIS. */

    if (verbose > 0)
      cprax1->jprint = verbose;

/*  KTM IS A CONVERGENCE SWITCH USED IN PRAXIS. */
/*  KTM+1 IS THE NUMBER OF ITERATIONS WITHOUT IMPROVEMENT */
/*  BEFORE THE ALGORITHM TERMINATES. */
/*  KTM=4 IS VERY CAUTIOUS. */
/*  USUALLY KTM=1 IS SATISFACTORY. */

    cprax1->ktm = 8;  /* WAS: 1 */

/*  H IS AN ESTIMATE OF THE DISTANCE FROM THE INITIAL POINT */
/*  TO THE SOLUTION. */

    cprax1->h = 0.1;  /* WAS: 0.01 */

/*  USE BISECTION TO COMPUTE THE VALUE OF EPSMCH, "MACHINE EPSILON". */
/*  EPSMCH IS THE SMALLEST FLOATING POINT (REAL OR DOUBLE PRECISION) */
/*  NUMBER WHICH, WHEN ADDED TO ONE, GIVES A RESULT GREATER THAN ONE. */

    a = rzero;
    b = unitr;
L10:
    xmid = a + (b - a) / rtwo;
    if (xmid <= a || xmid >= b) {
	goto L20;
    }
    xplus = unitr + xmid;
    if (xplus > unitr) {
	b = xmid;
    } else {
	a = xmid;
    }
    goto L10;

L20:
    cprax1->epsmch = b;

    /* Modified 21. 9. 2000 */
    cprax1->epsmch = 1000.*FLT_EPSILON;

    i__1 = cprax1->nmax;
    for (j = 1; j <= i__1; ++j) {
	cprax1->x[j - 1] = rzero;
	myassert(finite(cprax1->x[j - 1]) != 0);
/* L30: */
    }

/*  JRANCH = 1 TO USE BRENT'S RANDOM, */
/*  JRANCH = 2 TO USE FUNCTION DRANDM. */

    cprax1->jranch = 1;

    ranini_(&c_b83);

/*  DSEED IS AN INITIAL SEED FOR DRANDM, */
/*  A SUBROUTINE THAT GENERATES PSEUDORANDOM NUMBERS */
/*  UNIFORMLY DISTRIBUTED ON (0,1). */

    cprax1->dseed = 1234567.;

/*  SCBD IS AN UPPER BOUND ON THE SCALE FACTORS IN PRAXIS. */
/*  IF THE AXES MAY BE BADLY SCALED (WHICH IS TO BE AVOIDED IF */
/*  POSSIBLE) THEN SET SCBD = 10, OTHERWISE 1. */

    cprax1->scbd = 1.;

/*  ILLCIN IS THE INITIAL VALUE OF ILLC, */
/*  THE FLAG THAT SIGNALS AN ILL-CONDITIONED PROBLEM. */
/*  IF THE PROBLEM IS KNOWN TO BE ILL-CONDITIONED SET ILLCIN=1, */
/*  OTHERWISE 0. */

    cprax1->illcin = 0;

    return 0;

/*  END PRASET */

} /* praset_ */



/*  PRAXIS 2.0        JUNE 1995                                       */
/*                                                                    */
/*  THE PRAXIS PACKAGE MINIMIZES THE FUNCTION F(X,N) OF N             */
/*  VARIABLES X(1),...,X(N), USING THE PRINCIPAL AXIS METHOD.         */
/*  F MUST BE A SMOOTH (CONTINUOUSLY DIFFERENTIABLE) FUNCTION.        */
/*                                                                    */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",                */
/*     RICHARD P. BRENT, PRENTICE-HALL 1973 (ISBN 0-13-022335-2),     */
/*     PAGES 156-167                                                  */
/*                                                                    */
/*  TRANSLATED FROM ALGOL W TO A.N.S.I. 1966 STANDARD BASIC FORTRAN   */
/*     BY ROSALEE TAYLOR AND SUE PINSKI, COMPUTER SCIENCE DEPARTMENT, */
/*     OKLAHOMA STATE UNIVERSITY (DECEMBER 1973).                     */
/*                                                                    */
/*  UPDATED TO A.N.S.I. STANDARD FORTRAN 77 BY J. P. CHANDLER         */
/*     COMPUTER SCIENCE DEPARTMENT, OKLAHOMA STATE UNIVERSITY         */
/*                                                                    */
/*  SUBROUTINE PRAXIS CALLS SUBPROGRAMS                               */
/*     F, MIN, RANDOM (OR DRANDM), QUAD, MINFIT, SORT.                */
/*                                                                    */
/*  SUBROUTINE QUAD CALLS MIN.                                        */
/*  SUBROUTINE MIN CALLS FLIN.                                        */
/*  SUBROUTINE FLIN CALLS F.                                          */
/*                                                                    */
/*  INPUT QUANTITIES (SET IN THE CALLING PROGRAM)...                  */
/*     F        FUNCTION F(X,N) TO BE MINIMIZED                       */
/*     X(*)     INITIAL GUESS OF MINIMUM                              */
/*     N        DIMENSION OF X  (NOTE...  N MUST BE .GE. 2)           */
/*     H        MAXIMUM STEP SIZE                                     */
/*     T        TOLERANCE                                             */
/*     EPSMCH   MACHINE PRECISION                                     */
/*     JPRINT   PRINT SWITCH                                          */
/*                                                                    */
/*  OUTPUT QUANTITIES...                                              */
/*     X(*)     ESTIMATED POINT OF MINIMUM                            */
/*     FX       VALUE OF F AT X                                       */
/*     NL       NUMBER OF LINEAR SEARCHES                             */
/*     NF       NUMBER OF FUNCTION EVALUATIONS                        */
/*     V(*,*)   EIGENVECTORS OF A                                     */
/*                 NEW DIRECTIONS                                     */
/*     D(*)     EIGENVALUES OF A                                      */
/*                 NEW D                                              */
/*     Z(*)     SCALE FACTORS                                         */
/*                                                                    */
/*  ON ENTRY X(*) HOLDS A GUESS.  ON RETURN IT HOLDS THE ESTIMATED    */
/*  POINT OF MINIMUM, WITH (HOPEFULLY)                                */
/*  ABS(ERROR) LESS THAN SQRT(EPSMCH)*ABS(X) + T, WHERE               */
/*  EPSMCH IS THE MACHINE PRECISION, THE SMALLEST NUMBER SUCH THAT    */
/*  (1 + EPSMCH) IS GREATER THAN 1.                                   */
/*                                                                    */
/*  T IS A TOLERANCE.                                                 */
/*                                                                    */
/*  H IS THE MAXIMUM STEP SIZE, SET TO ABOUT THE MAXIMUM EXPECTED     */
/*  DISTANCE FROM THE GUESS TO THE MINIMUM.  IF H IS SET TOO          */
/*  SMALL OR TOO LARGE THEN THE INITIAL RATE OF CONVERGENCE WILL      */
/*  BE SLOW.                                                          */
/*                                                                    */
/*  THE USER SHOULD OBSERVE THE COMMENT ON HEURISTIC NUMBERS          */
/*  AT THE BEGINNING OF THE SUBROUTINE.                               */
/*                                                                    */
/*  JPRINT CONTROLS THE PRINTING OF INTERMEDIATE RESULTS.             */
/*  IT USES SUBROUTINES FLIN, MIN, QUAD, SORT, AND MINFIT.            */
/*  IF JPRINT = 1, F IS PRINTED AFTER EVERY N+1 OR N+2 LINEAR         */
/*  MINIMIZATIONS, AND FINAL X IS PRINTED, BUT INTERMEDIATE           */
/*  X ONLY IF N IS LESS THAN OR EQUAL TO 4.                           */
/*  IF JPRINT = 2, EIGENVALUES OF A AND SCALE FACTORS ARE ALSO PRTD.. */
/*  IF JPRINT = 3, F AND X ARE PRINTED AFTER EVERY FEW LINEAR         */
/*  MINIMIZATIONS.                                                    */
/*  IF JPRINT = 4, EIGENVECTORS ARE ALSO PRINTED.                     */
/*  IF JPRINT = 5, ADDITIONAL DEBUGGING INFORMATION IS ALSO PRINTED.  */
/*                                                                    */
/*  RANDOM RETURNS A RANDOM NUMBER UNIFORMLY DISTRIBUTED IN (0, 1).   */
/*                                                                    */
/*  THIS SUBROUTINE IS MACHINE-INDEPENDENT, APART FROM THE            */
/*  SPECIFICATION OF EPSMCH.  WE ASSUME THAT EPSMCH**(-4) DOES NOT    */
/*  OVERFLOW (IF IT DOES THEN EPSMCH MUST BE INCREASED), AND THAT ON  */
/*  FLOATING-POINT UNDERFLOW THE RESULT IS SET TO ZERO.               */

int praxis_(cprax_ * cprax1,double (*f)())
{

    /* System generated locals */
    int i__1, i__2, i__3;
    double d__1;

    /* Local variables */
    static double zero, rhalf, two, one, tenth, hundth, hundrd, pt9, ten;
    int illc;
    double xlds;
    double e[MAXLINES];
    int i, j, k;
    double s, y[MAXLINES], z[MAXLINES], f1;
    int k2;
    double t2, f1valu, df, dldfac, dn;
    int ik, im, kl;
    double sf, ranval;
    int kt;
    double sl;
    static double vlarge;
    static double xlarge;
    static double vsmall;
    int km1;
    double fxvalu;
    int imu;

/*  INITIALIZATION... */

    rhalf = .5;
    one = 1.;
    tenth = .1;
    hundth = .01;
    hundrd = 100.;
    zero = 0.;
    pt9 = .9;
    ten = 10.;
    two = 2.;

/*  MACHINE DEPENDENT NUMBERS... */

/*  ON MANY COMPUTERS, VSMALL WILL UNDERFLOW, */
/*  AND COMPUTING XLARGE MAY CAUSE A DIVISION BY ZERO. */
/*  IN THAT CASE, EPSMCH SHOULD BE SET EQUAL TO 1.0D-9 */
/*  (OR POSSIBLY 1.0D-8) BEFORE CALLING PRAXIS. */

    cprax1->small = cprax1->epsmch * cprax1->epsmch;
    vsmall = cprax1->small * cprax1->small;
    xlarge = one / cprax1->small;
    vlarge = one / vsmall;
    cprax1->xm2 = sqrt(cprax1->epsmch);
    cprax1->xm4 = sqrt(cprax1->xm2);

/*  HEURISTIC NUMBERS... */

/*  IF THE AXES MAY BE BADLY SCALED (WHICH IS TO BE AVOIDED IF */
/*  POSSIBLE) THEN SET SCBD = 10, OTHERWISE 1. */

/*  IF THE PROBLEM IS KNOWN TO BE ILL-CONDITIONED SET ILLC = 1, */
/*  OTHERWISE 0. */

/*  KTM+1 IS THE NUMBER OF ITERATIONS WITHOUT IMPROVEMENT */
/*  BEFORE THE ALGORITHM TERMINATES. */
/*  KTM=4 IS VERY CAUTIOUS. */
/*  USUALLY KTM=1 IS SATISFACTORY. */

/*  BRENT RECOMMENDED THE FOLLOWING VALUES FOR MOST PROBLEMS... */

/*                    SCBD=1.0 */
/*                    ILLC=0 */
/*                    KTM=1 */

/*  SCBD, ILLCIN, AND KTM ARE NOW IN COMMON. */
/*  THEY ARE INITIALIZED IN SUBROUTINE PRASET, */
/*  AND CAN BE RESET BY THE USER AFTER CALLING PRASET. */

    illc = cprax1->illcin;

    if (illc == 1) {
	dldfac = tenth;
    } else {
	dldfac = hundth;
    }

    kt = 0;
    cprax1->nl = 0;
    cprax1->nf = 1;
#ifndef NDEBUG
    for (gi = 0; gi < cprax1->n; ++gi)
      fprintf(stderr, "L %d %d %f\n", __LINE__, gi, cprax1->x[gi]);
#endif
    cprax1->fx = (*f)(cprax1->x, &(cprax1->n));
    cprax1->qf1 = cprax1->fx;
    cprax1->t = cprax1->small + fabs(cprax1->t);
    t2 = cprax1->t;
    cprax1->dmin__ = cprax1->small;
    if (cprax1->h < hundrd * cprax1->t) {
	cprax1->h = hundrd * cprax1->t;
    }
    cprax1->xldt = cprax1->h;

    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
	i__2 = cprax1->n;
	for (j = 1; j <= i__2; ++j) {
	    cprax1->v[i + j * MAXLINES - (MAXLINES + 1)] = zero;
/* L10: */
	}
	cprax1->v[i + i * MAXLINES - (MAXLINES + 1)] = one;
/* L20: */
    }

    cprax1->qd0 = zero;
    cprax1->d[0] = zero;

/*  Q0(*) AND Q1(*) ARE PREVIOUS X(*) POINTS, */
/*  INITIALIZED IN PRAXIS, USED IN FLIN, */
/*  AND CHANGED IN QUAD. */

    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
	cprax1->q1[i - 1] = cprax1->x[i - 1];

/*  Q0(*) WAS NOT INITIALIZED IN BRENT'S ALGOL PROCEDURE. */

	cprax1->q0[i - 1] = cprax1->x[i - 1];
/* L30: */
    }

         if (cprax1->jprint > 1)
	   {
	     fprintf(stdout, 
		     "Message      : powell(): NL = %10d, NF = %10d, "\
		     "FX = %15.7g\n",
		     cprax1->nl, cprax1->nf, cprax1->fx);
	     fprintf(stdout, "Message      : ");
	     for (i = 0; i < cprax1->n; ++i)
	       fprintf(stdout, " X[%d]=%15.7g", i, cprax1->x[i]);
	     fprintf(stdout, "\n");
	   }


/*  MAIN LOOP... */
/*  LABEL L0... */

L60:
    sf = cprax1->d[0];
    s = zero;
    cprax1->d[0] = zero;

/*  MINIMIZE ALONG THE FIRST DIRECTION. */

    fxvalu = cprax1->fx;
    mymin_(cprax1,&c__1, &c__2, cprax1->d, &s, &fxvalu, &c__0, f);

    if (s <= zero) {
	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {
	    cprax1->v[i - 1] = -cprax1->v[i - 1];
/* L80: */
	}
    }

    if (sf <= pt9 * cprax1->d[0] || pt9 * sf >= cprax1->d[0]) {

	if (cprax1->n >= 2) {
	    i__1 = cprax1->n;
	    for (i = 2; i <= i__1; ++i) {
		cprax1->d[i - 1] = zero;
/* L90: */
	    }
	}

    }

    if (cprax1->n < 2) {
	goto L320;
    }
    i__1 = cprax1->n;
    for (k = 2; k <= i__1; ++k) {

	i__2 = cprax1->n;
	for (i = 1; i <= i__2; ++i) {
	    y[i - 1] = cprax1->x[i - 1];
/* L100: */
	}

	sf = cprax1->fx;
	if (kt > 0) {
	    illc = 1;
	}

/*  LABEL L1... */

L110:
	kl = k;
	df = zero;

	if (illc == 1) {

/*  TAKE A RANDOM STEP TO GET OUT OF A RESOLUTION VALLEY. */

/*  PRAXIS ASSUMES THAT RANDOM (OR DRANDM) RETURNS */
/*  A PSEUDORANDOM NUMBER UNIFORMLY DISTRIBUTED IN (0,1), */
/*  AND THAT ANY INITIALIZATION OF THE RANDOM NUMBER GENERATOR */
/*  HAS ALREADY BEEN DONE. */

	    i__2 = cprax1->n;
	    for (i = 1; i <= i__2; ++i) {

		if (cprax1->jranch == 1) {
		    random_(&ranval);
		} else {
		    ranval = drandm_(&(cprax1->dseed));
		}

		s = (tenth * cprax1->xldt + t2 * pow(ten, kt)) * (ranval 
			- rhalf);
		z[i - 1] = s;

		i__3 = cprax1->n;
		for (j = 1; j <= i__3; ++j) {
		    cprax1->x[j - 1] += s * cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
		    myassert(finite(cprax1->x[j - 1]) != 0);
/* L120: */
		}
/* L130: */
	    }

#ifndef NDEBUG
    for (gi = 0; gi < cprax1->n; ++gi)
      fprintf(stderr, "L %d %d %f\n", __LINE__, gi, cprax1->x[gi]);
#endif
    cprax1->fx = (*f)(cprax1->x, &(cprax1->n));
	    ++cprax1->nf;

	    if (cprax1->jprint > 1)
	      {
		printf ("Message      : powell(): RANDOM STEP. "\
			"s = %15.7g\n"\
			"Message      : X[0] = %15.7g, X[1] = %15.7g,\n"
			"Message      : NF = %10d, fx = %15.7g\n",
			s, cprax1->x[0], cprax1->x[1], 
			cprax1->nf, cprax1->fx);
	      }


	}

	if (k > cprax1->n) {
	    goto L170;
	}
	i__2 = cprax1->n;
	for (k2 = k; k2 <= i__2; ++k2) {
	    sl = cprax1->fx;
	    s = zero;

/*  MINIMIZE ALONG NON-CONJUGATE DIRECTIONS. */

	    fxvalu = cprax1->fx;
	    mymin_(cprax1,&k2, &c__2, &(cprax1->d[k2 - 1]), &s, &fxvalu, &c__0, f);

	    if (illc == 1) {
/* Computing 2nd power */
		d__1 = s + z[k2 - 1];
		s = cprax1->d[k2 - 1] * (d__1 * d__1);
	    } else {
		s = sl - cprax1->fx;
	    }

	    if (df < s) {
		df = s;
		kl = k2;
	    }
/* L160: */
	}

L170:
	d__1 = hundrd * cprax1->epsmch * cprax1->fx;
	if (illc == 0 && df < abs(d__1)) {

/*  NO SUCCESS WITH ILLC=0, SO TRY ONCE WITH ILLC=1 . */

	    illc = 1;

/*  GO TO L1. */

	    goto L110;
	}

	if (k == 2 && cprax1->jprint > 1)
	  fprintf(stdout, 
		  "Message      : powell(): New D %15.7g, ...\n", cprax1->d[0]);


	km1 = k - 1;
	if (km1 < 1) {
	    goto L210;
	}
	i__2 = km1;
	for (k2 = 1; k2 <= i__2; ++k2) {

/*  MINIMIZE ALONG CONJUGATE DIRECTIONS. */

	    s = zero;
	    fxvalu = cprax1->fx;
	    mymin_(cprax1,&k2, &c__2, &(cprax1->d[k2 - 1]), &s, &fxvalu, &c__0, f);
/* L200: */
	}

L210:
	f1 = cprax1->fx;
	cprax1->fx = sf;

	xlds = zero;
	i__2 = cprax1->n;
	for (i = 1; i <= i__2; ++i) {
	    sl = cprax1->x[i - 1];
	    cprax1->x[i - 1] = y[i - 1];
	    myassert(finite(cprax1->x[i - 1]) != 0);
	    sl -= y[i - 1];
	    y[i - 1] = sl;
	    xlds += sl * sl;
/* L220: */
	}

	xlds = sqrt(xlds);
	if (xlds > cprax1->small) {

/*  THROW AWAY THE DIRECTION KL AND MINIMIZE ALONG */
/*  THE NEW CONJUGATE DIRECTION. */

	    ik = kl - 1;
	    if (k > ik) {
		goto L250;
	    }
	    i__2 = ik;
	    for (im = k; im <= i__2; ++im) {
		i = ik - im + k;

		i__3 = cprax1->n;
		for (j = 1; j <= i__3; ++j) {
		    cprax1->v[j + (i + 1) * MAXLINES - (MAXLINES + 1)] = cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
/* L230: */
		}

		cprax1->d[i] = cprax1->d[i - 1];
/* L240: */
	    }

L250:
	    cprax1->d[k - 1] = zero;

	    i__2 = cprax1->n;
	    for (i = 1; i <= i__2; ++i) {
		cprax1->v[i + k * MAXLINES - (MAXLINES + 1)] = y[i - 1] / xlds;
/* L260: */
	    }

	    f1valu = f1;
	    mymin_(cprax1,&k, &c__4, &(cprax1->d[k - 1]), &xlds, &f1valu, &c__1, f);

	    if (xlds <= zero) {
		xlds = -xlds;

		i__2 = cprax1->n;
		for (i = 1; i <= i__2; ++i) {
		    cprax1->v[i + k * MAXLINES - (MAXLINES + 1)] = -cprax1->v[i + k * MAXLINES - (MAXLINES + 1)];
/* L280: */
		}
	    }
	}

	cprax1->xldt = dldfac * cprax1->xldt;
	if (cprax1->xldt < xlds) {
	    cprax1->xldt = xlds;
	}

         if (cprax1->jprint > 1)
          {
	    fprintf(stdout, "Message      : powell(): NL = %10d, NF = %10d, "\
		   "FX = %15.7g\n", 
                  cprax1->nl, cprax1->nf, cprax1->fx);
	    fprintf(stdout, "Message      : ");	    
	    for (i = 0; i < cprax1->n; ++i)
              fprintf(stdout, " X[%d]=%15.7g", i, cprax1->x[i]);
	    fprintf(stdout, "\n");
          }

	t2 = zero;
	i__2 = cprax1->n;
	for (i = 1; i <= i__2; ++i) {
/* Computing 2nd power */
	    d__1 = cprax1->x[i - 1];
	    t2 += d__1 * d__1;
/* L290: */
	}
	t2 = cprax1->xm2 * sqrt(t2) + cprax1->t;

/*  SEE IF THE STEP LENGTH EXCEEDS HALF THE TOLERANCE. */

	if (cprax1->xldt > rhalf * t2) {
	    kt = 0;
	} else {
	    ++kt;
	}

/*  IF(...) GO TO L2 */

	if (kt > cprax1->ktm) {
	    goto L550;
	}

	if (cprax1->nf >= cprax1->nfmax) {
	  fprintf(stderr, "* Warning *: powell(): NO CONVERGENCE: "\
		  "NFMAX (%11d) EXCEEDED.\n",
		  cprax1->nfmax);
	  goto L550;
	}

/* L310: */
    }

/*  TRY QUADRATIC EXTRAPOLATION IN CASE WE ARE STUCK IN A CURVED VALLEY. 
*/

L320:
    quad_(cprax1,f);

    dn = zero;
    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
	cprax1->d[i - 1] = one / sqrt(cprax1->d[i - 1]);
	if (dn < cprax1->d[i - 1]) {
	    dn = cprax1->d[i - 1];
	}
/* L330: */
    }


    i__1 = cprax1->n;
    for (j = 1; j <= i__1; ++j) {

	s = cprax1->d[j - 1] / dn;
	i__2 = cprax1->n;
	for (i = 1; i <= i__2; ++i) {
	    cprax1->v[i + j * MAXLINES - (MAXLINES + 1)] = s * cprax1->v[i + j * MAXLINES - (MAXLINES + 1)];
/* L370: */
	}
/* L380: */
    }

    if (cprax1->scbd > one) {

/*  SCALE THE AXES TO TRY TO REDUCE THE CONDITION NUMBER. */

	s = vlarge;
	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {

	    sl = zero;
	    i__2 = cprax1->n;
	    for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
		d__1 = cprax1->v[i + j * MAXLINES - (MAXLINES + 1)];
		sl += d__1 * d__1;
/* L390: */
	    }

	    z[i - 1] = sqrt(sl);
	    if (z[i - 1] < cprax1->xm4) {
		z[i - 1] = cprax1->xm4;
	    }
	    if (s > z[i - 1]) {
		s = z[i - 1];
	    }
/* L400: */
	}

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {
	    sl = s / z[i - 1];
	    z[i - 1] = one / sl;

	    if (z[i - 1] > cprax1->scbd) {
		sl = one / cprax1->scbd;
		z[i - 1] = cprax1->scbd;
	    }

/*  IT APPEARS THAT THERE ARE TWO MISSING END; STATEMENTS */
/*  AT THIS POINT IN BRENT'S LISTING. */

/* L410: */
	}
    }

/*  TRANSPOSE V FOR MINFIT. */

    if (cprax1->n < 2) {
	goto L440;
    }
    i__1 = cprax1->n;
    for (i = 2; i <= i__1; ++i) {

	imu = i - 1;
	i__2 = imu;
	for (j = 1; j <= i__2; ++j) {
	    s = cprax1->v[i + j * MAXLINES - (MAXLINES + 1)];
	    cprax1->v[i + j * MAXLINES - (MAXLINES + 1)] = cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
	    cprax1->v[j + i * MAXLINES - (MAXLINES + 1)] = s;
/* L420: */
	}
/* L430: */
    }

/*  FIND THE SINGULAR VALUE DECOMPOSITION OF V.   */
/*  THIS GIVES THE EIGENVALUES AND PRINCIPAL AXES */
/*  OF THE APPROXIMATING QUADRATIC FORM           */
/*  WITHOUT SQUARING THE CONDITION NUMBER.        */

L440:
    minfit_(cprax1,&(cprax1->n), &(cprax1->epsmch), &vsmall, cprax1->v, cprax1->d, e, &(cprax1->nmax), &(cprax1->lp));

    if (cprax1->scbd > one) {

/*  UNSCALING... */

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {

	    s = z[i - 1];
	    i__2 = cprax1->n;
	    for (j = 1; j <= i__2; ++j) {
		cprax1->v[i + j * MAXLINES - (MAXLINES + 1)] = s * cprax1->v[i + j * MAXLINES - (MAXLINES + 1)];
/* L450: */
	    }
/* L460: */
	}

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {

	    s = zero;
	    i__2 = cprax1->n;
	    for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
		d__1 = cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
		s += d__1 * d__1;
/* L470: */
	    }
	    s = sqrt(s);

	    cprax1->d[i - 1] = s * cprax1->d[i - 1];

	    s = one / s;
	    i__2 = cprax1->n;
	    for (j = 1; j <= i__2; ++j) {
		cprax1->v[j + i * MAXLINES - (MAXLINES + 1)] = s * cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
/* L480: */
	    }
/* L490: */
	}
    }

    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {

	if (dn * cprax1->d[i - 1] > xlarge) {
	    cprax1->d[i - 1] = vsmall;
	} else if (dn * cprax1->d[i - 1] < cprax1->small) {
	    cprax1->d[i - 1] = vlarge;
	} else {
/* Computing 2nd power */
	    d__1 = dn * cprax1->d[i - 1];
	    cprax1->d[i - 1] = one / (d__1 * d__1);
	}
/* L500: */
    }

/*  SORT THE NEW EIGENVALUES AND EIGENVECTORS. */

    sort_(cprax1);

    cprax1->dmin__ = cprax1->d[cprax1->n - 1];
    if (cprax1->dmin__ < cprax1->small) {
	cprax1->dmin__ = cprax1->small;
    }

    if (cprax1->xm2 * cprax1->d[0] > cprax1->dmin__) {
	illc = 1;
    } else {
	illc = 0;
    }


/*  GO BACK TO THE MAIN LOOP. */
/*  GO TO L0 */

/*  HANDLE THE CASE N .EQ. 1 IN AN AD HOC WAY. */
/*  (BRENT DID NOT PROVIDE FOR THIS CASE.)     */

    if (cprax1->n >= 2) {
	goto L60;
    }

/*  LABEL L2... */

L550:
#ifndef NDEBUG
    for (gi = 0; gi < cprax1->n; ++gi)
      fprintf(stderr, "L %d %d %f\n", __LINE__, gi, cprax1->x[gi]);
#endif
    cprax1->fx = (*f)(cprax1->x, &(cprax1->n));

    if (cprax1->jprint > 1) {
      fprintf(stdout, 
	      "Message      : powell(): Exit praxis(): "\
	      "NL = %10d, NF = %10d, FX = %15.7g\n", 
	      cprax1->nl, cprax1->nf, cprax1->fx);
    }

    return 0;

} /* praxis_ */

/*  THIS SUBROUTINE LOOKS FOR THE MINIMUM ALONG        */
/*  A CURVE DEFINED BY Q0, Q1, AND X.                  */
/*                                                     */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES", */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGE 161     */
/*                                                     */
/*  SUBROUTINE QUAD IS CALLED BY SUBROUTINE PRAXIS.    */

int quad_(cprax_ * cprax1, double (*f) ())
{

    /* System generated locals */
    int i__1;
    double d__1;


    /* Local variables */
    static double zero, one;
    int i;
    double s;
    double qf1val, qa, qb, qc, xl;


    zero = 0.;
    one = 1.;

    s = cprax1->fx;
    cprax1->fx = cprax1->qf1;
    cprax1->qf1 = s;
    cprax1->qd1 = zero;

    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
	s = cprax1->x[i - 1];
	xl = cprax1->q1[i - 1];
	cprax1->x[i - 1] = xl;
	myassert(finite(cprax1->x[i - 1]) != 0);
	cprax1->q1[i - 1] = s;
/* Computing 2nd power */
	d__1 = s - xl;
	cprax1->qd1 += d__1 * d__1;
/* L10: */
    }

    cprax1->qd1 = sqrt(cprax1->qd1);
    xl = cprax1->qd1;
    s = zero;

    if (cprax1->qd0 > zero && cprax1->qd1 > zero && cprax1->nl >= cprax1->n * 
	    3 * cprax1->n) {

	qf1val = cprax1->qf1;
	mymin_(cprax1,&c__0, &c__2, &s, &xl, &qf1val, &c__1, f);
	qa = xl * (xl - cprax1->qd1) / (cprax1->qd0 * (cprax1->qd0 + 
		cprax1->qd1));
	qb = (xl + cprax1->qd0) * (cprax1->qd1 - xl) / (cprax1->qd0 * 
		cprax1->qd1);
	qc = xl * (xl + cprax1->qd0) / (cprax1->qd1 * (cprax1->qd0 + 
		cprax1->qd1));
    } else {
	cprax1->fx = cprax1->qf1;
	qa = zero;
	qb = zero;
	qc = one;
    }

    cprax1->qd0 = cprax1->qd1;

    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
	s = cprax1->q0[i - 1];
	cprax1->q0[i - 1] = cprax1->x[i - 1];
	cprax1->x[i - 1] = qa * s + qb * cprax1->x[i - 1] + qc * cprax1->q1[i 
		- 1];
	myassert(finite(cprax1->x[i - 1]) != 0);
/* L30: */
    }

    return 0;

/*  END QUAD */

} /* quad_ */


/*  SUBROUTINE MIN MINIMIZES F FROM X IN THE DIRECTION V(*,J)     */
/*  UNLESS J IS LESS THAN 1, WHEN A QUADRATIC SEARCH IS DONE IN   */
/*  THE PLANE DEFINED BY Q0, Q1, AND X.                           */
/*                                                                */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",            */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 159-160           */
/*                                                                */
/*  SUBROUTINE MIN IS CALLED BY SUBROUTINES PRAXIS AND QUAD.      */
/*                                                                */
/*  D2 AND X1 RETURN RESULTS.                                     */
/*  J, NITS, F1 AND IFK ARE VALUE PARAMETERS THAT RETURN NOTHING. */
/*  DO NOT SEND A COMMON VARIABLE TO MIN FOR PARAMETER F1.        */
/*                                                                */
/*  D2 IS AN APPROXIMATION TO HALF OF                             */
/*  THE SECOND DERIVATIVE OF F (OR ZERO).                         */
/*                                                                */
/*  X1 IS AN ESTIMATE OF DISTANCE TO MINIMUM,                     */
/*  RETURNED AS THE DISTANCE FOUND.                               */
/*                                                                */
/*  IF IFK = 1 THEN F1 IS FLIN(X1), OTHERWISE X1 AND F1 ARE       */
/*  IGNORED ON ENTRY UNLESS FINAL FX IS GREATER THAN F1.          */
/*                                                                */
/*  NITS CONTROLS THE NUMBER OF TIMES AN ATTEMPT IS MADE TO       */
/*  HALVE THE INTERVAL.                                           */

int mymin_(cprax1, j, nits, d2, x1, f1, ifk, f)
cprax_ * cprax1;
int *j, *nits;
double *d2, *x1, *f1;
int *ifk;
double (*f) ();
{

    /* System generated locals */
    int i__1;
    double d__1;

    /* Local variables */
    static double zero, two, rhalf,  hundth;
    int i, k;
    double s,  denom, d1, f0, f2, t2, x2, fm, xm,  
	    sf1, sx1;
    int idz;

#ifndef NDEBUG
    fprintf(stderr, "mymin_ (%d %d %f %f %f %d, func)\n",
	    *j, *nits, *d2, *x1, *f1, *ifk);
#endif

    hundth = .01;
    zero = 0.;
    two = 2.;
    rhalf = .5;

    sf1 = *f1;
    sx1 = *x1;
    k = 0;
    xm = zero;
    fm = cprax1->fx;
    f0 = cprax1->fx;

    if (*d2 < cprax1->epsmch) {
	idz = 1;
    } else {
	idz = 0;
    }

#ifndef NDEBUG
    fprintf(stderr, "L %d: %f %f %d\n", __LINE__, *d2, cprax1->epsmch, idz);
#endif


/*  FIND THE STEP SIZE. */

    s = zero;
    i__1 = cprax1->n;
    for (i = 1; i <= i__1; ++i) {
/* Computing 2nd power */
	d__1 = cprax1->x[i - 1];
	s += d__1 * d__1;
/* L10: */
    }
    s = sqrt(s);

#ifndef NDEBUG
    fprintf(stderr, "L %d: %d %f\n", __LINE__, i__1, s);
#endif


    if (idz == 1) {
	denom = cprax1->dmin__;
    } else {
	denom = *d2;
    }

#ifndef NDEBUG
    fprintf(stderr, "L %d: %d %f\n", __LINE__, idz, denom);
#endif

    d__1 = abs(cprax1->fx) / denom + s * cprax1->xldt;
    t2 = cprax1->xm4 * sqrt(d__1) + cprax1->xm2 * cprax1->xldt;
    s = cprax1->xm4 * s + cprax1->t;

#ifndef NDEBUG
    fprintf(stderr, "L %d: d__1 %f, xm4 %f, xm2 %f, xldt %f, t2 %f, s %f\n", 
	    __LINE__, d__1, cprax1->xm4, cprax1->xm2,
	    cprax1->xldt, t2, s);
#endif

    if (idz == 1 && (t2 > s || finite(t2) == 0)) {
	t2 = s;
    }
    if (t2 < cprax1->small) {
	t2 = cprax1->small;
    }
    if ((t2 > hundth * cprax1->h) || finite(t2) == 0) {
	t2 = hundth * cprax1->h;
    }

    if (*ifk == 1 && *f1 <= fm) {
	xm = *x1;
	fm = *f1;
    }

    if (*ifk == 0 || abs(*x1) < t2) {

	if (*x1 >= zero) {
	    *x1 = t2;
	} else {
	    *x1 = -t2;
	}
	myassert(finite(*x1) != 0); 
	flin_(cprax1, x1, j, f, f1);
    }

    if (*f1 < fm) {
	xm = *x1;
	fm = *f1;
    }

/*  LABEL L0... */

L20:
    if (idz == 1) {

/*  EVALUATE FLIN AT ANOTHER POINT, */
/*  AND ESTIMATE THE SECOND DERIVATIVE. */

	if (f0 < *f1) {
	    x2 = -(*x1);
	} else {
	    x2 = two * *x1;
	}
	myassert(finite(x2) != 0);
	flin_(cprax1,&x2, j, f, &f2);

	if (f2 <= fm) {
	    xm = x2;
	    fm = f2;
	}

        myassert(finite(x2) != 0);
	*d2 = (x2 * (*f1 - f0) - *x1 * (f2 - f0)) / (*x1 * x2 * (*x1 - x2));
	myassert(finite(*d2) != 0);

    }

/*  ESTIMATE THE FIRST DERIVATIVE AT 0. */

    d1 = (*f1 - f0) / *x1 - *x1 * *d2;
    idz = 1;

/*  PREDICT THE MINIMUM. */

    if (*d2 <= cprax1->small) {

	if (d1 < zero) {
	    x2 = cprax1->h;
	} else {
	    x2 = -cprax1->h;
	}

    } else {
	x2 = -rhalf * d1 / *d2;
    }

    if (abs(x2) > cprax1->h) {

	if (x2 > zero) {
	    x2 = cprax1->h;
	} else {
	    x2 = -cprax1->h;
	}
    }

/*  EVALUATE F AT THE PREDICTED MINIMUM. */
/*  LABEL L1... */

L40:
    myassert(finite(x2) != 0);
    flin_(cprax1,&x2, j, f, &f2);

    if ( (k < *nits) && (f2 > f0)) {

/*  NO SUCCESS, SO TRY AGAIN. */

	++k;

/*  IF(...) GO TO L0 */

	if (f0 < *f1 && *x1 * x2 > zero) {
	    goto L20;
	}
	x2 /= two;

/*  GO TO L1 */
	goto L40;

    }

/*  INCREMENT THE ONE-DIMENSIONAL SEARCH COUNTER. */

    ++cprax1->nl;

    if (f2 > fm) {
	x2 = xm;
    } else {
	fm = f2;
    }

/*  GET A NEW ESTIMATE OF THE SECOND DERIVATIVE. */

    d__1 = x2 * (x2 - *x1);
    if (abs(d__1) > cprax1->small) {
	*d2 = (x2 * (*f1 - f0) - *x1 * (fm - f0)) / (*x1 * x2 * (*x1 - x2));


    } else if (k > 0) {
	*d2 = zero;

    } else {
	*d2 = *d2;
    }

    if (*d2 <= cprax1->small) {
	*d2 = cprax1->small;

    }

    *x1 = x2;
    cprax1->fx = fm;
    if (sf1 < cprax1->fx) {
	cprax1->fx = sf1;
	*x1 = sx1;
    }

/*  UPDATE X FOR A LINEAR SEARCH BUT NOT FOR A PARABOLIC SEARCH. */

    if (*j > 0) {

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {
	    cprax1->x[i - 1] += *x1 * cprax1->v[i + *j * MAXLINES - (MAXLINES + 1)];
	    myassert(finite(cprax1->x[i - 1]) != 0);
/* L90: */
	}
    }
    return 0;

/*  END MIN */

} /* mymin_ */


/*  FLIN IS A FUNCTION OF ONE VARIABLE XL WHICH IS MINIMIZED BY */
/*  SUBROUTINE MIN.                                             */
/*                                                              */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",          */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 159-160         */
/*                                                              */
/*  SUBROUTINE FLIN IS CALLED BY SUBROUTINE MIN.                */

int flin_(cprax1, xl, j, f, fln)
cprax_ * cprax1;
double *xl;
int *j;
double (*f) ();
double *fln;
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int i;
    double qa, qb, qc, tt[2 * MAXLINES];

#ifndef NDEBUG
    fprintf (stderr, "flin_ (%f, %d, func, %f)\n", *xl, *j, *fln);
#endif

    if (*j > 0) {

/*  LINEAR SEARCH... */

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {
	    tt[i - 1] = cprax1->x[i - 1] + *xl * cprax1->v[i + *j * MAXLINES - (MAXLINES + 1)];
#ifndef NDEBUG
	    fprintf(stderr, "branch 1: tt[%d] = %f\n", i-1, tt[i-1]);
#endif
/* L10: */
	}

    } else {

/*  SEARCH ALONG A PARABOLIC SPACE CURVE. */

	qa = *xl * (*xl - cprax1->qd1) / (cprax1->qd0 * (cprax1->qd0 + 
		cprax1->qd1));
	qb = (*xl + cprax1->qd0) * (cprax1->qd1 - *xl) / (cprax1->qd0 * 
		cprax1->qd1);
	qc = *xl * (*xl + cprax1->qd0) / (cprax1->qd1 * (cprax1->qd0 + 
		cprax1->qd1));

	i__1 = cprax1->n;
	for (i = 1; i <= i__1; ++i) {
	    tt[i - 1] = qa * cprax1->q0[i - 1] + qb * cprax1->x[i - 1] + qc * 
		    cprax1->q1[i - 1];
#ifndef NDEBUG
	    fprintf(stderr, "branch 2: tt[%d] = %f\n", i-1, tt[i-1]);
#endif
/* L20: */
	}
    }

/*  INCREMENT FUNCTION EVALUATION COUNTER. */

    ++cprax1->nf;
#ifndef NDEBUG
    for (gi = 0; gi < cprax1->n; ++gi)
      fprintf(stderr, "L %d, %d %f\n", __LINE__, gi, tt[gi]);
#endif
    /* fprintf(stderr,"in = %f \n",cprax1->x[0]); *//* FIXME */
    *fln = (*f)(tt, &(cprax1->n));

    return 0;

} /* flin_ */


/*  AN IMPROVED VERSION OF MINFIT, RESTRICTED TO M=N, P=0.       */
/*  SEE GOLUB AND REINSCH (1970).                                */
/*                                                               */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",           */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 156-158          */
/*                                                               */
/*  G. H. GOLUB AND C. REINSCH,                                  */
/*  "SINGULAR VALUE DECOMPOSITION AND LEAST SQUARES SOLUTIONS',  */
/*  NUMERISCHE MATHEMATIK 14 (1970) PAGES 403-420                */
/*                                                               */
/*  THE SINGULAR VALUES OF THE ARRAY AB ARE RETURNED IN Q,       */
/*  AND AB IS OVERWRITTEN WITH THE ORTHOGONAL MATRIX V SUCH THAT */
/*  U.DIAG(Q)=AB.V, WHERE U IS ANOTHER ORTHOGONAL MATRIX.        */
/*                                                               */
/*  SUBROUTINE MINFIT IS CALLED BY SUBROUTINE PRAXIS.            */

int minfit_(cprax1, n, eps, tol, ab, q, e, nmax, lp)
cprax_ * cprax1;
int *n;
double *eps, *tol, *ab, *q, *e;
int *nmax, *lp;
{

    /* System generated locals */
    int ab_dim1, ab_offset, i__1, i__2, i__3;
    double d__1, d__2;


    /* Local variables */
    double c, f, g, h;
    int i, j, k, l = 0;
    double s, x, y, z, denom;
    int l2, ii, kk, kt, jthirt, ll2;
    static double one;
    int lpi;
    static double zero, two;



    /* Parameter adjustments */
    --e;
    --q;
    ab_dim1 = *nmax;
    ab_offset = ab_dim1 + 1;
    ab -= ab_offset;

    /* Function Body */
    jthirt = 30;

    zero = 0.;
    one = 1.;
    two = 2.;

/*  HOUSEHOLDER'S REDUCTION TO BIDIAGONAL FORM... */

    x = zero;
    g = zero;

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	e[i] = g;
	s = zero;
	l = i + 1;

	i__2 = *n;
	for (j = i; j <= i__2; ++j) {
/* Computing 2nd power */
	    d__1 = ab[j + i * ab_dim1];
	    s += d__1 * d__1;
/* L10: */
	}

	if (s < *tol) {
	    g = zero;
	} else {
	    f = ab[i + i * ab_dim1];

	    if (f < zero) {
		g = sqrt(s);
	    } else {
		g = -sqrt(s);
	    }

	    h = f * g - s;
	    ab[i + i * ab_dim1] = f - g;

	    if (l > *n) {
		goto L60;
	    }
	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {

		f = zero;
		if (i > *n) {
		    goto L30;
		}
		i__3 = *n;
		for (k = i; k <= i__3; ++k) {
		    f += ab[k + i * ab_dim1] * ab[k + j * ab_dim1];
/* L20: */
		}
L30:
		f /= h;

		if (i > *n) {
		    goto L50;
		}
		i__3 = *n;
		for (k = i; k <= i__3; ++k) {
		    ab[k + j * ab_dim1] += f * ab[k + i * ab_dim1];
/* L40: */
		}
L50:
		;
	    }
	}

L60:
	q[i] = g;
	s = zero;

	if (i <= *n) {

	    if (l > *n) {
		goto L80;
	    }
	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {
/* Computing 2nd power */
		d__1 = ab[i + j * ab_dim1];
		s += d__1 * d__1;
/* L70: */
	    }
	}

L80:
	if (s < *tol) {
	    g = zero;
	} else {
	    f = ab[i + (i + 1) * ab_dim1];

	    if (f < zero) {
		g = sqrt(s);
	    } else {
		g = -sqrt(s);
	    }

	    h = f * g - s;
	    ab[i + (i + 1) * ab_dim1] = f - g;
	    if (l > *n) {
		goto L130;
	    }
	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {
		e[j] = ab[i + j * ab_dim1] / h;
/* L90: */
	    }

	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {

		s = zero;
		i__3 = *n;
		for (k = l; k <= i__3; ++k) {
		    s += ab[j + k * ab_dim1] * ab[i + k * ab_dim1];
/* L100: */
		}

		i__3 = *n;
		for (k = l; k <= i__3; ++k) {
		    ab[j + k * ab_dim1] += s * e[k];
/* L110: */
		}
/* L120: */
	    }
	}

L130:
	y = (d__1 = q[i], abs(d__1)) + (d__2 = e[i], abs(d__2));

	if (y > x) {
	    x = y;
	}
/* L140: */
    }

/*  ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS... */

    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
	i = *n - ii + 1;

	if (g != zero) {
	    h = ab[i + (i + 1) * ab_dim1] * g;

	    if (l > *n) {
		goto L200;
	    }
	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {
		ab[j + i * ab_dim1] = ab[i + j * ab_dim1] / h;
/* L150: */
	    }

	    i__2 = *n;
	    for (j = l; j <= i__2; ++j) {

		s = zero;
		i__3 = *n;
		for (k = l; k <= i__3; ++k) {
		    s += ab[i + k * ab_dim1] * ab[k + j * ab_dim1];
/* L160: */
		}

		i__3 = *n;
		for (k = l; k <= i__3; ++k) {
		    ab[k + j * ab_dim1] += s * ab[k + i * ab_dim1];
/* L170: */
		}
/* L180: */
	    }
	}

	if (l > *n) {
	    goto L200;
	}
	i__2 = *n;
	for (j = l; j <= i__2; ++j) {
	    ab[j + i * ab_dim1] = zero;
	    ab[i + j * ab_dim1] = zero;
/* L190: */
	}

L200:
	ab[i + i * ab_dim1] = one;
	g = e[i];
	l = i;
/* L210: */
    }

/*  DIAGONALIZATION OF THE BIDIAGONAL FORM... */

    *eps *= x;
    i__1 = *n;
    for (kk = 1; kk <= i__1; ++kk) {
	k = *n - kk + 1;
	kt = 0;

/*  LABEL TESTFSPLITTING... */

L220:
	++kt;

	if (kt > jthirt) {
	    e[k] = zero;
	}

	i__2 = k;
	for (ll2 = 1; ll2 <= i__2; ++ll2) {
	    l2 = k - ll2 + 1;
	    l = l2;

/*  IF(...) GO TO TESTFCONVERGENCE */

	    if ((d__1 = e[l], abs(d__1)) <= *eps) {
		goto L270;
	    }

/*  IF(...) GO TO CANCELLATION */

	    if ((d__1 = q[l - 1], abs(d__1)) <= *eps) {
		goto L250;
	    }
/* L240: */
	}

/*  CANCELLATION OF E(L) IF L IS GREATER THAN 1... */
/*  LABEL CANCELLATION... */

L250:
	c = zero;
	s = one;
	if (l > k) {
	    goto L270;
	}
	i__2 = k;
	for (i = l; i <= i__2; ++i) {
	    f = s * e[i];
	    e[i] = c * e[i];

/*  IF(...) GO TO TESTFCONVERGENCE */

	    if (abs(f) <= *eps) {
		goto L270;
	    }
	    g = q[i];

	    if (abs(f) < abs(g)) {
/* Computing 2nd power */
		d__2 = f / g;
		d__1 = one + d__2 * d__2;
		h = abs(g) * sqrt(d__1);
	    } else if (f != zero) {
/* Computing 2nd power */
		d__2 = g / f;
		d__1 = one + d__2 * d__2;
		h = abs(f) * sqrt(d__1);
	    } else {
		h = zero;
	    }

	    q[i] = h;

	    if (h == zero) {
		h = one;
		g = one;
	    }

/*  THE ABOVE REPLACES Q(I) AND H BY SQUARE ROOT OF (G*G+F*F)       */
/*  WHICH MAY GIVE INCORRECT RESULTS IF THE SQUARES UNDERFLOW OR IF */
/*  F = G = 0 .                                                     */

	    c = g / h;
	    s = -f / h;
/* L260: */
	}

/*  LABEL TESTFCONVERGENCE... */

L270:
	z = q[k];

/*  IF(...) GO TO CONVERGENCE */

	if (l == k) {
	    goto L310;
	}

/*  SHIFT FROM BOTTOM 2*2 MINOR. */

	x = q[l];
	y = q[k - 1];
	g = e[k - 1];
	h = e[k];
	f = ((y - z) * (y + z) + (g - h) * (g + h)) / (two * h * y);
	d__1 = f * f + one;
	g = sqrt(d__1);

	if (f < zero) {
	    denom = f - g;
	} else {
	    denom = f + g;
	}

	f = ((x - z) * (x + z) + h * (y / denom - h)) / x;

/*  NEXT QR TRANSFORMATION... */

	s = one;
	c = one;
	lpi = l + 1;
	if (lpi > k) {
	    goto L300;
	}
	i__2 = k;
	for (i = lpi; i <= i__2; ++i) {
	    g = e[i];
	    y = q[i];
	    h = s * g;
	    g *= c;

	    if (abs(f) < abs(h)) {
/* Computing 2nd power */
		d__2 = f / h;
		d__1 = one + d__2 * d__2;
		z = abs(h) * sqrt(d__1);
	    } else if (f != zero) {
/* Computing 2nd power */
		d__2 = h / f;
		d__1 = one + d__2 * d__2;
		z = abs(f) * sqrt(d__1);
	    } else {
		z = zero;
	    }

	    e[i - 1] = z;

	    if (z == zero) {
		f = one;
		z = one;
	    }

	    c = f / z;
	    s = h / z;
	    f = x * c + g * s;
	    g = -x * s + g * c;
	    h = y * s;
	    y *= c;

	    i__3 = *n;
	    for (j = 1; j <= i__3; ++j) {
		x = ab[j + (i - 1) * ab_dim1];
		z = ab[j + i * ab_dim1];
		ab[j + (i - 1) * ab_dim1] = x * c + z * s;
		ab[j + i * ab_dim1] = -x * s + z * c;
/* L280: */
	    }

	    if (abs(f) < abs(h)) {
/* Computing 2nd power */
		d__2 = f / h;
		d__1 = one + d__2 * d__2;
		z = abs(h) * sqrt(d__1);
	    } else if (f != zero) {
/* Computing 2nd power */
		d__2 = h / f;
		d__1 = one + d__2 * d__2;
		z = abs(f) * sqrt(d__1);
	    } else {
		z = zero;
	    }

	    q[i - 1] = z;

	    if (z == zero) {
		f = one;
		z = one;
	    }

	    c = f / z;
	    s = h / z;
	    f = c * g + s * y;
	    x = -s * g + c * y;
/* L290: */
	}

L300:
	e[l] = zero;
	e[k] = f;
	q[k] = x;

/*  GO TO TESTFSPLITTING */

	goto L220;

/*  LABEL CONVERGENCE... */

L310:
	if (z < zero) {

/*  Q(K) IS MADE NON-NEGATIVE. */

	    q[k] = -z;
	    i__2 = *n;
	    for (j = 1; j <= i__2; ++j) {
		ab[j + k * ab_dim1] = -ab[j + k * ab_dim1];
/* L320: */
	    }
	}
/* L330: */
    }

    return 0;

/*  END MINFIT */

} /* minfit_ */

/*  THIS SUBROUTINE SORTS THE ELEMENTS OF D                   */
/*  AND THE CORRESPONDING COLUMNS OF V INTO DESCENDING ORDER. */
/*                                                            */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",        */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 158-159       */
 
int sort_(cprax_ * cprax1)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    int i, j, k;
    double s;
    int ipi, nmi;

    nmi = cprax1->n - 1;
    if (nmi < 1) {
	goto L50;
    }
    i__1 = nmi;
    for (i = 1; i <= i__1; ++i) {
	k = i;
	s = cprax1->d[i - 1];
	ipi = i + 1;
	if (ipi > cprax1->n) {
	    goto L20;
	}

	i__2 = cprax1->n;
	for (j = ipi; j <= i__2; ++j) {

	    if (cprax1->d[j - 1] > s) {
		k = j;
		s = cprax1->d[j - 1];
	    }
/* L10: */
	}

L20:
	if (k > i) {
	    cprax1->d[k - 1] = cprax1->d[i - 1];
	    cprax1->d[i - 1] = s;

	    i__2 = cprax1->n;
	    for (j = 1; j <= i__2; ++j) {
		s = cprax1->v[j + i * MAXLINES - (MAXLINES + 1)];
		cprax1->v[j + i * MAXLINES - (MAXLINES + 1)] = cprax1->v[j + k * MAXLINES - (MAXLINES + 1)];
		cprax1->v[j + k * MAXLINES - (MAXLINES + 1)] = s;
/* L30: */
	    }
	}
/* L40: */
    }

L50:
    return 0;

} /* sort_ */

double d_mod (double * a1, double * a2)
{
  return (*a1 - ( *a2 * (int)(*a1/(*a2))));
}


/*  SUBROUTINE RANINI PERFORMS INITIALIZATION FOR SUBROUTINE RANDOM. */
/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES",               */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 163-164              */

int ranini_(rvalue)
double *rvalue;
{
    /* System generated locals */
    double d__1;


    /* Local variables */
    int i;
    double r;

    d__1 = abs(*rvalue);
    r = d_mod(&d__1, &c_b310) + 1;
    comran_1.jran2 = 127;

L10:
    if (comran_1.jran2 > 0) {
	--comran_1.jran2;
	comran_1.ran1 = -36028797018963968.;

	for (i = 1; i <= 7; ++i) {
	    d__1 = r * 1756.;
	    r = d_mod(&d__1, &c_b313);
	    comran_1.ran1 = (comran_1.ran1 + (r - d_mod(&r, &c_b314)) / 32.) /
		     256.;
/* L20: */
	}

	comran_1.ran3[comran_1.jran2] = comran_1.ran1;
	goto L10;
    }

    return 0;

} /* ranini_ */


int random_(ranval)
double *ranval;
{

/*  SUBROUTINE RANDOM RETURNS A DOUBLE PRECISION PSEUDORANDOM NUMBER */
/*  UNIFORMLY DISTRIBUTED IN (0,1) (INCLUDING 0 BUT NOT 1). */

/*  "ALGORITHMS FOR MINIMIZATION WITHOUT DERIVATIVES", */
/*  RICHARD P. BRENT, PRENTICE-HALL 1973, PAGES 163-164 */

/*  BEFORE THE FIRST CALL TO RANDOM, THE USER MUST */
/*  CALL RANINI(R) ONCE (ONLY) WITH R A DOUBLE PRECISION NUMBER */
/*  EQUAL TO ANY INT VALUE. */
/*  BRENT (PAGE 166) USED THE EQUIVALENT OF */
/*     CALL RANINI(4.0D0) . */

/*  THE ALGORITHM USED IN SUBROUTINE RANDOM RETURNS X(N)/2**56, */
/*  WHERE   X(N) = X(N-1) + X(N-127)  (MOD 2**56) . */
/*  SINCE (1 + X + X**127) IS PRIMITIVE (MOD 2), */
/*  THE PERIOD IS AT LEAST (2**127 - 1), WHICH EXCEEDS 10**38. */

/*  SEE "SEMINUMERICAL ALGORITHMS", VOLUME 2 OF */
/*  "THE ART OF COMPUTER PROGRAMMING" BY DONALD E. KNUTH, */
/*  ADDISON-WESLEY 1969, PAGES 26, 34, AND 464. */

/*  X(N) IS STORED IN DOUBLE PRECISION AS  RAN3 = X(N)/2**56 - 1/2, */
/*  AND ALL DOUBLE PRECISION ARITHMETIC IS EXACT. */




    if (comran_1.jran2 == 0) {
	comran_1.jran2 = 126;
    } else {
	--comran_1.jran2;
    }

    comran_1.ran1 += comran_1.ran3[comran_1.jran2];
    if (comran_1.ran1 < 0.) {
	comran_1.ran1 += .5;
    } else {
	comran_1.ran1 += -.5;
    }

    comran_1.ran3[comran_1.jran2] = comran_1.ran1;
    *ranval = comran_1.ran1 + .5;

    return 0;

/*  END RANDOM */

} /* random_ */

double drandm_(dl)
double *dl;
{
    /* System generated locals */
    double ret_val, d__1;



/*  SIMPLE PORTABLE PSEUDORANDOM NUMBER GENERATOR. */

/*  DRANDM RETURNS FUNCTION VALUES THAT ARE PSEUDORANDOM */
/*  NUMBERS UNIFORMLY DISTRIBUTED ON THE INTERVAL (0,1). */

/*  'NUMERICAL MATHEMATICS AND COMPUTING' BY WARD CHENEY AND */
/*  DAVID KINCAID, BROOKS/COLE PUBLISHING COMPANY */
/*  (FIRST EDITION, 1980), PAGE 203 */

/*  AT THE BEGINNING OF EXECUTION, OR WHENEVER A NEW SEQUENCE IS */
/*  TO BE INITIATED, SET DL EQUAL TO AN INT VALUE BETWEEN */
/*  1.0D0 AND 2147483646.0D0, INCLUSIVE.  DO THIS ONLY ONCE. */
/*  THEREAFTER, DO NOT SET OR ALTER DL IN ANY WAY. */
/*  FUNCTION DRANDM WILL MODIFY DL FOR ITS OWN PURPOSES. */

/*  DRANDM USES A MULTIPLICATIVE CONGRUENTIAL METHOD. */
/*  THE NUMBERS GENERATED BY DRANDM SUFFER FROM THE PARALLEL */
/*  PLANES DEFECT DISCOVERED BY G. MARSAGLIA, AND SHOULD NOT BE */
/*  USED WHEN HIGH-QUALITY RANDOMNESS IS REQUIRED.  IN THAT */
/*  CASE, USE A "SHUFFLING" METHOD. */


L10:
    d__1 = *dl * 16807.;
    *dl = d_mod(&d__1, &c_b318);
    ret_val = *dl / 2147483647.;
    if (ret_val <= 0. || ret_val >= 1.) {
	goto L10;
    }
    return ret_val;
} /* drandm_ */

